//package com.example.navigationbaato.activity
//
//import android.annotation.SuppressLint
//import android.content.BroadcastReceiver
//import android.content.Context
//import android.content.Intent
//import android.location.Location
//import android.os.Build
//import android.os.Bundle
//import android.os.VibrationEffect
//import android.os.Vibrator
//import android.speech.tts.TextToSpeech
//import android.util.Log
//import android.view.View
//import android.widget.Toast
//import androidx.appcompat.app.AppCompatActivity
//import androidx.constraintlayout.widget.ConstraintLayout
//import androidx.transition.TransitionManager
//import butterknife.BindView
//import butterknife.ButterKnife
//import com.example.navigationbaato.R
//import com.google.android.material.snackbar.Snackbar
//import com.mapbox.android.core.location.LocationEngine
//import com.mapbox.api.directions.v5.models.DirectionsResponse
//import com.mapbox.api.directions.v5.models.DirectionsRoute
//import com.mapbox.geojson.Point
//import com.mapbox.mapboxsdk.Mapbox
//import com.mapbox.mapboxsdk.camera.CameraPosition
//import com.mapbox.mapboxsdk.camera.CameraUpdateFactory
//import com.mapbox.mapboxsdk.geometry.LatLng
//import com.mapbox.mapboxsdk.geometry.LatLngBounds
//import com.mapbox.mapboxsdk.maps.MapView
//import com.mapbox.mapboxsdk.maps.MapboxMap
//import com.mapbox.mapboxsdk.maps.OnMapReadyCallback
//import com.mapbox.mapboxsdk.plugins.locationlayer.LocationLayerPlugin
//import com.mapbox.mapboxsdk.plugins.locationlayer.modes.RenderMode
//import com.mapbox.services.android.navigation.ui.v5.SoundButton
//import com.mapbox.services.android.navigation.ui.v5.instruction.InstructionView
//import com.mapbox.services.android.navigation.ui.v5.listeners.SpeechAnnouncementListener
//import com.mapbox.services.android.navigation.ui.v5.map.NavigationMapboxMap
//import com.mapbox.services.android.navigation.ui.v5.route.NavigationMapRoute
//import com.mapbox.services.android.navigation.ui.v5.summary.SummaryBottomSheet
//import com.mapbox.services.android.navigation.ui.v5.voice.NavigationSpeechPlayer
//import com.mapbox.services.android.navigation.ui.v5.voice.SpeechAnnouncement
//import com.mapbox.services.android.navigation.ui.v5.voice.SpeechPlayerProvider
//import com.mapbox.services.android.navigation.v5.instruction.Instruction
//import com.mapbox.services.android.navigation.v5.location.replay.ReplayRouteLocationEngine
//import com.mapbox.services.android.navigation.v5.milestone.*
//import com.mapbox.services.android.navigation.v5.navigation.MapboxNavigation
//import com.mapbox.services.android.navigation.v5.navigation.MapboxNavigationOptions
//import com.mapbox.services.android.navigation.v5.navigation.NavigationEventListener
//import com.mapbox.services.android.navigation.v5.offroute.OffRouteListener
//import com.mapbox.services.android.navigation.v5.routeprogress.ProgressChangeListener
//import com.mapbox.services.android.navigation.v5.routeprogress.RouteProgress
//import java.lang.ref.WeakReference
//import java.util.*
//
//class MockNavigationActivity : AppCompatActivity(), OnMapReadyCallback,
//    ProgressChangeListener, MilestoneEventListener, OffRouteListener, NavigationEventListener,
//    SpeechAnnouncementListener {
//    private var mTts: TextToSpeech? = null
//
//    var navigationLayout: ConstraintLayout? = null
//    var mapView: MapView? = null
//    var instructionView: InstructionView? = null
//
//    var summaryBottomSheet: SummaryBottomSheet? = null
//    private var locationEngine: LocationEngine? = null
//    private var locationLayerPlugin: LocationLayerPlugin? = null
//    private var navigation: MapboxNavigation? = null
//    private var speechPlayer: NavigationSpeechPlayer? = null
//    private val navigationMap: NavigationMapboxMap? = null
//    private var lastLocation: Location? = null
//    private var route: DirectionsRoute? = null
//    private val destination: Point? = null
//    private var mapState: MapState? = null
//    private var mapboxMap: MapboxMap? = null
//    private val navigationMode = "car"
//    private var origin: Point? = null
//    var directionsResponse: DirectionsResponse? = null
//    private var navigationMapRoute: NavigationMapRoute? = null
//    private var soundButton: SoundButton? = null
//    private var isMuted = false
//    override fun onRunning(running: Boolean) {
//        Log.wtf("Status: ", running.toString())
//    }
//
//    override fun willVoice(announcement: SpeechAnnouncement): String? {
//        return null
//    }
//
//    private class MyBroadcastReceiver internal constructor(navigation: MapboxNavigation) :
//        BroadcastReceiver() {
//        private val weakNavigation: WeakReference<MapboxNavigation>
//        override fun onReceive(context: Context, intent: Intent) {
//            val navigation = weakNavigation.get()
//            navigation!!.stopNavigation()
//        }
//
//        init {
//            weakNavigation = WeakReference(navigation)
//        }
//    }
//
//    private enum class MapState {
//        INFO, NAVIGATION
//    }
//
//    override fun onCreate(savedInstanceState: Bundle?) {
//        super.onCreate(savedInstanceState)
//        // For styling the InstructionView
//        setTheme(R.style.CustomInstructionView)
//        setContentView(R.layout.component_navigation)
//        Mapbox.getInstance(applicationContext, null)
//        ButterKnife.bind(this)
//        val extras = intent.extras
//        if (extras != null) {
//            directionsResponse = extras["Route"] as DirectionsResponse?
//            route = directionsResponse!!.routes()[0]
//            origin = extras["origin"] as Point?
//            lastLocation = extras["lastLocation"] as Location?
//            // and get whatever type user account id is
//        }
//        mapView = findViewById(R.id.mapView)
//        navigationLayout = findViewById(R.id.componentNavigationLayout)
//        instructionView = findViewById(R.id.instructionView)
//        summaryBottomSheet = findViewById(R.id.summaryBottomSheet)
//        mapView!!.setStyleUrl("http://api-staging.baato.io/api/v1/styles/breeze?key=" + Constants.token)
//        mapView!!.onCreate(savedInstanceState)
//
//        // Will call onMapReady
//        mapView!!.getMapAsync(this)
//        //        CustomNavigationNotification customNotification = new CustomNavigationNotification(getApplicationContext());
////        .navigationNotification(customNotification)
//        val options = MapboxNavigationOptions.builder()
//            .defaultMilestonesEnabled(true)
//            .build()
//        navigation = MapboxNavigation(this, Constants.token, options)
//        navigation!!.addMilestone(
//            RouteMilestone.Builder()
//                .setIdentifier(BEGIN_ROUTE_MILESTONE)
//                .setInstruction(BeginRouteInstruction())
//                .setTrigger(Trigger.all())
//                .build()
//        )
//        //    navigation.addMilestone(new RouteMilestone.Builder()
////            .setIdentifier(BEGIN_ROUTE_MILESTONE)
////            .setInstruction(new BeginRouteInstruction())
////            .setTrigger(
////                    Trigger.all(
////                            Trigger.lt(TriggerProperty.STEP_INDEX, 3),
////                            Trigger.gt(TriggerProperty.STEP_DISTANCE_TOTAL_METERS, 200),
////                            Trigger.gte(TriggerProperty.STEP_DISTANCE_TRAVELED_METERS, 5)
////                    )
////            ).build());
////        customNotification.register(new MyBroadcastReceiver(navigation), getApplicationContext());
//    }
//
//    private class BeginRouteInstruction : Instruction() {
//        override fun buildInstruction(routeProgress: RouteProgress): String {
//            return "Have a safe trip!"
//        }
//    }
//
//    override fun onMapReady(mapboxMap: MapboxMap) {
//        this.mapboxMap = mapboxMap
//        //remove mapbox attribute
//        mapboxMap.uiSettings.isAttributionEnabled = false
//        mapboxMap.uiSettings.isLogoEnabled = false
//        mapboxMap.setStyleUrl(
//            "http://api-staging.baato.io/api/v1/styles/breeze?key=" + Constants.token
//        ) { //    mapboxMap.setStyleUrl("http://178.128.59.143:8080/api/v2/styles/a1e37ae99cdb4f29910cdf27a51a0282.json");
//            mapboxMap.cameraPosition = CameraPosition.Builder()
//                .target(LatLng(origin!!.latitude(), origin!!.longitude()))
//                .zoom(14.0)
//                .build()
//            initializeSpeechPlayer()
//            mapState = MapState.NAVIGATION
//            locationLayerPlugin = LocationLayerPlugin(mapView!!, mapboxMap)
//            locationLayerPlugin!!.renderMode =
//                RenderMode.GPS
//            locationLayerPlugin!!.isLocationLayerEnabled = false
//            navigationMapRoute = NavigationMapRoute(navigation, mapView!!, mapboxMap)
//            navigationMapRoute!!.addRoute(route)
//            locationEngine = ReplayRouteLocationEngine()
//            onNavigationReady()
//        }
//    }
//
//    fun onNavigationReady() {
//        if (navigation != null && route != null) {
//            // Transition to navigation state
//            TransitionManager.beginDelayedTransition(navigationLayout!!)
//            instructionView!!.visibility = View.VISIBLE
//            summaryBottomSheet!!.visibility = View.VISIBLE
//            // Attach all of our navigation listeners.
//            navigation!!.addNavigationEventListener(this)
//            navigation!!.addProgressChangeListener(this)
//            navigation!!.addOffRouteListener(this)
//            navigation!!.addMilestoneEventListener(this)
//            //      navigation.addMilestoneEventListener(new MilestoneEventListener() {
////        @Override
////        public void onMilestoneEvent(RouteProgress routeProgress, String instruction, Milestone milestone) {
////          Log.d("milestone", instruction);
////        }
////      });
//            (locationEngine as ReplayRouteLocationEngine?)!!.assign(route)
//            //      ((ReplayRouteLocationEngine) locationEngine).updateSpeed(100);
//            navigation!!.locationEngine = locationEngine!!
//            locationLayerPlugin!!.isLocationLayerEnabled = true
//            navigation!!.startNavigation(route!!)
//            soundButton = instructionView!!.findViewById(R.id.soundLayout)
//            soundButton!!.addOnClickListener(View.OnClickListener {
//                isMuted = soundButton!!.toggleMute()
//            })
//        }
//    }
//
//    /*
//   * Navigation listeners
//   */
//    override fun onProgressChange(location: Location, routeProgress: RouteProgress) {
//
//        // Cache "snapped" Locations for re-route Directions API requests
//        var location: Location? = location
//        if (location == null) {
//            location = lastLocation
//        }
//        locationLayerPlugin!!.forceLocationUpdate(location)
//        moveCameraTo(location)
//        // Update InstructionView data from RouteProgress
//        instructionView!!.update(routeProgress)
//        summaryBottomSheet!!.update(routeProgress)
//        //    Log.d("Progress", String.valueOf(routeProgress.currentStepPoints()));
////    Log.d("Location", String.valueOf(location));
//    }
//
//    override fun onMilestoneEvent(
//        routeProgress: RouteProgress,
//        instruction: String,
//        milestone: Milestone
//    ) {
////    Log.d("milestone", instruction);
//        playAnnouncement(milestone)
//    }
//
//    override fun userOffRoute(location: Location) {
//        calculateRouteWith(destination, true)
//    }
//
//    /*
//   * Activity lifecycle methods
//   */
//    public override fun onResume() {
//        super.onResume()
//        mapView!!.onResume()
//    }
//
//    public override fun onPause() {
//        super.onPause()
//        mapView!!.onPause()
//    }
//
//    override fun onStart() {
//        super.onStart()
//        mapView!!.onStart()
//        if (locationLayerPlugin != null) {
//            locationLayerPlugin!!.onStart()
//        }
//    }
//
//    override fun onSaveInstanceState(outState: Bundle) {
//        super.onSaveInstanceState(outState)
//        mapView!!.onSaveInstanceState(outState)
//    }
//
//    override fun onStop() {
//        super.onStop()
//        mapView!!.onStop()
//        if (locationLayerPlugin != null) {
//            locationLayerPlugin!!.onStop()
//        }
//    }
//
//    override fun onLowMemory() {
//        super.onLowMemory()
//        mapView!!.onLowMemory()
//    }
//
//    override fun onDestroy() {
//        super.onDestroy()
//        //        mapView.onDestroy();
//
//        // Ensure proper shutdown of the SpeechPlayer
//        if (speechPlayer != null) {
//            speechPlayer!!.onDestroy()
//        }
//        if (navigation != null) {
////            ((DynamicCamera) navigation.getCameraEngine()).clearMap();
//            // MapboxNavigation will shutdown the LocationEngine
//            navigation!!.onDestroy()
//        }
//        locationEngine!!.removeLocationUpdates()
//        locationEngine!!.deactivate()
//        mapView!!.onDestroy()
//    }
//
//    private fun initializeSpeechPlayer() {
//        val locale = Locale("en", "US")
//        val english = locale.language
//        //    String english = Locale.US.getLanguage();
//
////    String accessToken = Mapbox.getAccessToken();
////      String accessToken = "pk.xxx";
//        val speechPlayerProvider = SpeechPlayerProvider(application, english, true, Constants.token)
//        speechPlayer = NavigationSpeechPlayer(speechPlayerProvider)
//        mTts = TextToSpeech(this) {
//            if (mTts!!.engines.size == 0) {
//                Toast.makeText(
//                    this@MockNavigationActivity,
//                    "No voice engine found",
//                    Toast.LENGTH_SHORT
//                ).show()
//            } else {
//                mTts!!.language = locale
//            }
//        }
//        //      speechPlayer.speak(text, TextToSpeech.QUEUE_ADD, null);
//    }
//
//    private fun showSnackbar(text: String, duration: Int) {
//        Snackbar.make(navigationLayout!!, text, duration).show()
//    }
//
//    private fun playAnnouncement(milestone: Milestone) {
//        if (!isMuted) {
//            if (milestone is VoiceInstructionMilestone) {
//                val announcement = SpeechAnnouncement.builder()
//                    .voiceInstructionMilestone(milestone)
//                    .build()
//                mTts!!.speak(announcement.announcement(), TextToSpeech.QUEUE_ADD, null)
//                Log.d("Announcement", announcement.announcement())
//                //        speechPlayer.play(announcement);
//            }
//        }
//    }
//
//    private fun moveCameraTo(location: Location?) {
//        val cameraPosition = buildCameraPositionFrom(location, location!!.bearing.toDouble())
//        mapboxMap!!.animateCamera(
//            CameraUpdateFactory.newCameraPosition(cameraPosition), TWO_SECONDS_IN_MILLISECONDS
//        )
//    }
//
//    private fun moveCameraToInclude(destination: Point) {
//        val origin = LatLng(lastLocation)
//        val bounds = LatLngBounds.Builder()
//            .include(origin)
//            .include(LatLng(destination.latitude(), destination.longitude()))
//            .build()
//        val resources = resources
//        val routeCameraPadding = 56
//        val padding = intArrayOf(
//            routeCameraPadding,
//            routeCameraPadding,
//            routeCameraPadding,
//            routeCameraPadding
//        )
//        val cameraPosition = navigationMap!!.retrieveMap().getCameraForLatLngBounds(bounds, padding)
//        navigationMap.retrieveMap().animateCamera(
//            CameraUpdateFactory.newCameraPosition(cameraPosition), TWO_SECONDS_IN_MILLISECONDS
//        )
//    }
//
//    private fun moveCameraOverhead() {
//        if (lastLocation == null) {
//            return
//        }
//        val cameraPosition = buildCameraPositionFrom(lastLocation, DEFAULT_BEARING)
//        navigationMap!!.retrieveMap().animateCamera(
//            CameraUpdateFactory.newCameraPosition(cameraPosition), TWO_SECONDS_IN_MILLISECONDS
//        )
//    }
//
//    private fun buildCameraPositionFrom(location: Location?, bearing: Double): CameraPosition {
//        return CameraPosition.Builder()
//            .zoom(DEFAULT_ZOOM)
//            .target(LatLng(location!!.latitude, location.longitude))
//            .bearing(bearing)
//            .tilt(DEFAULT_TILT)
//            .build()
//    }
//
//    private fun adjustMapPaddingForNavigation() {
//        val resources = resources
//        val mapViewHeight = mapView!!.height
//        val bottomSheetHeight = 96
//        val topPadding = mapViewHeight - bottomSheetHeight * BOTTOMSHEET_PADDING_MULTIPLIER
//        navigationMap!!.retrieveMap()
//            .setPadding(ZERO_PADDING, topPadding, ZERO_PADDING, ZERO_PADDING)
//    }
//
//    private fun resetMapAfterNavigation() {
//        navigationMap!!.removeRoute()
//        navigationMap.clearMarkers()
//        navigation!!.stopNavigation()
//        moveCameraOverhead()
//    }
//
//    private fun calculateRouteWith(destination: Point?, isOffRoute: Boolean) {
//        val origin = Point.fromLngLat(lastLocation!!.longitude, lastLocation!!.latitude)
//        val bearing = java.lang.Float.valueOf(lastLocation!!.bearing).toDouble()
//        if (destination == null) {
//            return
//        }
//        getRoute(origin, destination, isOffRoute)
//    }
//
//    private fun getRoute(origin: Point, destination: Point, isOffRoute: Boolean) {
//        val points = arrayOfNulls<String>(2)
//        points[0] = origin.latitude().toString() + "," + origin.longitude()
//        points[1] = destination.latitude().toString() + "," + destination.longitude()
//        //    new BaatoRouting(this)
////            .setPoints(points)
////            .setAccessToken(Constants.token)
////            .setMode(navigationMode) //eg bike, car, foot
////            .setAlternatives(false) //optional parameter
////            .setInstructions(true) //optional parameter
////            .withListener(new BaatoRouting.BaatoRoutingRequestListener() {
////              @Override
////              public void onSuccess(DirectionsAPIResponse directionResponse) {
////                NavResponse navResponse = directionResponse.getData().get(0);
////                double distanceInKm = navResponse.getDistanceInMeters() / 1000;
////                long time = navResponse.getTimeInMs() / 1000;
////
////                ObjectNode parsedNavigationResponse = NavigateResponseConverter.convertFromGHResponse(directionResponse.getData().get(0), navigationMode);
////                DirectionsResponse directionsResponse = DirectionsResponse.fromJson(String.valueOf(parsedNavigationResponse));
////                route = directionsResponse.routes().get(0);
////                handleRoute(directionsResponse, isOffRoute);
////              }
////
////              @Override
////              public void onFailed(Throwable t) {
////                if (t.getMessage() != null && t.getMessage().contains("Failed to connect"))
////                  Toast.makeText(getApplicationContext(), "Please connect to internet to get the routes!", Toast.LENGTH_SHORT).show();
////
////              }
////            })
////            .doRequest();
//    }
//
//    private fun handleRoute(response: DirectionsResponse, isOffRoute: Boolean) {
//        val routes = response.routes()
//        if (!routes.isEmpty()) {
//            route = routes[FIRST]
//            navigationMap!!.drawRoute(route!!)
//            if (isOffRoute) {
//                navigation!!.startNavigation(route!!)
//            }
//        }
//    }
//
//    @SuppressLint("MissingPermission")
//    private fun vibrate() {
//        val vibrator = getSystemService(VIBRATOR_SERVICE) as Vibrator
//        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
//            vibrator.vibrate(
//                VibrationEffect.createOneShot(
//                    ONE_HUNDRED_MILLISECONDS.toLong(),
//                    VibrationEffect.DEFAULT_AMPLITUDE
//                )
//            )
//        } else {
//            vibrator.vibrate(ONE_HUNDRED_MILLISECONDS.toLong())
//        }
//    }
//
//    companion object {
//        private const val FIRST = 0
//        private const val ONE_HUNDRED_MILLISECONDS = 100
//        private const val BOTTOMSHEET_PADDING_MULTIPLIER = 4
//        private const val TWO_SECONDS_IN_MILLISECONDS = 2000
//        private const val BEARING_TOLERANCE = 90.0
//        private const val LONG_PRESS_MAP_MESSAGE = "Long press the map to select a destination."
//        private const val SEARCHING_FOR_GPS_MESSAGE = "Searching for GPS..."
//        private const val ZERO_PADDING = 0
//        private const val DEFAULT_ZOOM = 14.0
//        private const val DEFAULT_TILT = 0.0
//        private const val DEFAULT_BEARING = 0.0
//        private const val ONE_SECOND_INTERVAL = 1000
//        private const val BEGIN_ROUTE_MILESTONE = 1001
//    }
//}
